package com.foreverwin.mesnac.meapi.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author Ervin Chen
 * @since 2020-10-19
 */

@TableName("ITEM")
public class Item extends Model<Item> {

    private static final long serialVersionUID = 1L;

   @TableId(value = "HANDLE", type = IdType.INPUT)
   private String handle;
   @TableField("CHANGE_STAMP")
   private Long changeStamp;
   @TableField("SITE")
   private String site;
   @TableField("ITEM")
   private String item;
   @TableField(exist = false)
   private String description;
   @TableField("STATUS_BO")
   private String statusBo;
   @TableField("ITEM_TYPE")
   private String itemType;
   @TableField("ERP_GTIN")
   private String erpGtin;
   @TableField("AIN_MODEL_EXTERNAL_ID")
   private String ainModelExternalId;
   @TableField("EFF_START_SEQ")
   private Long effStartSeq;
   @TableField("EFF_END_SEQ")
   private Long effEndSeq;
   @TableField("LOT_SIZE")
   private Double lotSize;
   @TableField("QUANTITY_RESTRICTION")
   private String quantityRestriction;
   @TableField("ROUTER_BO")
   private String routerBo;
   @TableField("BOM_BO")
   private String bomBo;
   @TableField("COMPONENT_GROUP_BO")
   private String componentGroupBo;
   @TableField("ITEM_GROUP_BO")
   private String itemGroupBo;
   @TableField("LAST_RELEASED_DATE")
   private LocalDateTime lastReleasedDate;
   @TableField("ASSY_DATA_TYPE_BO")
   private String assyDataTypeBo;
   @TableField("PRE_ASSEMBLED")
   private String preAssembled;
   @TableField("REVISION")
   private String revision;
   @TableField("CURRENT_REVISION")
   private String currentRevision;
   @TableField("EFF_START_DATE")
   private LocalDateTime effStartDate;
   @TableField("EFF_END_DATE")
   private LocalDateTime effEndDate;
   @TableField("SELECTOR_ACTIVITY_BO")
   private String selectorActivityBo;
   @TableField("SELECTOR_NOTE")
   private String selectorNote;
   @TableField("ASSIGN_SERIAL_AT_RELEASE")
   private String assignSerialAtRelease;
   @TableField("CREATED_DATE_TIME")
   private LocalDateTime createdDateTime;
   @TableField("MODIFIED_DATE_TIME")
   private LocalDateTime modifiedDateTime;
   @TableField("DRAWING_NAME")
   private String drawingName;
   @TableField("MAXIMUM_USAGE")
   private Long maximumUsage;
   @TableField("USE_COMP_FROM_DRAWING")
   private String useCompFromDrawing;
   @TableField("PANEL")
   private String panel;
   @TableField("REMOVAL_ASSY_DATA_TYPE_BO")
   private String removalAssyDataTypeBo;
   @TableField("INV_ASSY_DATA_TYPE_BO")
   private String invAssyDataTypeBo;
   @TableField("ORIGINAL_STATUS_BO")
   private String originalStatusBo;
   @TableField("QTY_MULTIPLIER")
   private Double qtyMultiplier;
   @TableField("CREATE_TRACKABLE_SFC")
   private String createTrackableSfc;
   @TableField("MASK_GROUP_BO")
   private String maskGroupBo;
   @TableField("TRANSFER_ITEM_GROUP_BO")
   private String transferItemGroupBo;
   @TableField("UNIT_OF_MEASURE")
   private String unitOfMeasure;
   @TableField("HOLD_ID")
   private Long holdId;
   @TableField("COLLECT_PARENT_SERIAL")
   private String collectParentSerial;
   @TableField("REQ_SERIAL_CHANGE")
   private String reqSerialChange;
   @TableField("IS_COLLECTOR")
   private String isCollector;
   @TableField("INC_BATCH_NUMBER")
   private String incBatchNumber;
   @TableField("TIME_SENSITIVE")
   private String timeSensitive;
   @TableField("MAX_SHELF_LIFE")
   private Double maxShelfLife;
   @TableField("MAX_SHELF_LIFE_UNITS")
   private String maxShelfLifeUnits;
   @TableField("MAX_FLOOR_LIFE")
   private Double maxFloorLife;
   @TableField("MAX_FLOOR_LIFE_UNITS")
   private String maxFloorLifeUnits;
   @TableField("NOTES")
   private String notes;
   @TableField("TB_COMP_TYPE")
   private String tbCompType;
   @TableField("CONSUMPTION_TOL")
   private Double consumptionTol;
   @TableField("ERP_BACKFLUSHING")
   private String erpBackflushing;
   @TableField("STORAGE_LOCATION_BO")
   private String storageLocationBo;
   @TableField("ERP_PUTAWAY_STORLOC")
   private String erpPutawayStorloc;
   @TableField("PRODUCTION_SUPPLY_AREA")
   private String productionSupplyArea;
   @TableField("USE_ORDER_ID_REL1")
   private String useOrderIdRel1;
   @TableField("MATERIAL_TYPE")
   private String materialType;
   @TableField("PROCUREMENT_TYPE")
   private String procurementType;
   @TableField("ORIGIN")
   private String origin;
   @TableField(exist = false)
   private String customerid;
   @TableField(exist = false)
   private String labelControl;
   @TableField(exist = false)
   private String batchControl;
   @TableField(exist = false)
   private String mapNo;

   public String getLabelControl() {
      return labelControl;
   }

   public void setLabelControl(String labelControl) {
      this.labelControl = labelControl;
   }

   public String getBatchControl() {
      return batchControl;
   }

   public void setBatchControl(String batchControl) {
      this.batchControl = batchControl;
   }

   public String getHandle() {
      return handle;
   }

   public void setHandle(String handle) {
      this.handle = handle;
   }

   public Long getChangeStamp() {
      return changeStamp;
   }

   public void setChangeStamp(Long changeStamp) {
      this.changeStamp = changeStamp;
   }

   public String getSite() {
      return site;
   }

   public void setSite(String site) {
      this.site = site;
   }

   public String getItem() {
      return item;
   }

   public void setItem(String item) {
      this.item = item;
   }

   public String getDescription() {
      return description;
   }

   public void setDescription(String description) {
      this.description = description;
   }

   public String getCustomerid() {
      return customerid;
   }

   public void setCustomerid(String customerid) {
      this.customerid = customerid;
   }

   public String getStatusBo() {
      return statusBo;
   }

   public void setStatusBo(String statusBo) {
      this.statusBo = statusBo;
   }

   public String getItemType() {
      return itemType;
   }

   public void setItemType(String itemType) {
      this.itemType = itemType;
   }

   public String getErpGtin() {
      return erpGtin;
   }

   public void setErpGtin(String erpGtin) {
      this.erpGtin = erpGtin;
   }

   public String getAinModelExternalId() {
      return ainModelExternalId;
   }

   public void setAinModelExternalId(String ainModelExternalId) {
      this.ainModelExternalId = ainModelExternalId;
   }

   public Long getEffStartSeq() {
      return effStartSeq;
   }

   public void setEffStartSeq(Long effStartSeq) {
      this.effStartSeq = effStartSeq;
   }

   public Long getEffEndSeq() {
      return effEndSeq;
   }

   public void setEffEndSeq(Long effEndSeq) {
      this.effEndSeq = effEndSeq;
   }

   public Double getLotSize() {
      return lotSize;
   }

   public void setLotSize(Double lotSize) {
      this.lotSize = lotSize;
   }

   public String getQuantityRestriction() {
      return quantityRestriction;
   }

   public void setQuantityRestriction(String quantityRestriction) {
      this.quantityRestriction = quantityRestriction;
   }

   public String getRouterBo() {
      return routerBo;
   }

   public void setRouterBo(String routerBo) {
      this.routerBo = routerBo;
   }

   public String getBomBo() {
      return bomBo;
   }

   public void setBomBo(String bomBo) {
      this.bomBo = bomBo;
   }

   public String getComponentGroupBo() {
      return componentGroupBo;
   }

   public void setComponentGroupBo(String componentGroupBo) {
      this.componentGroupBo = componentGroupBo;
   }

   public String getItemGroupBo() {
      return itemGroupBo;
   }

   public void setItemGroupBo(String itemGroupBo) {
      this.itemGroupBo = itemGroupBo;
   }

   public LocalDateTime getLastReleasedDate() {
      return lastReleasedDate;
   }

   public void setLastReleasedDate(LocalDateTime lastReleasedDate) {
      this.lastReleasedDate = lastReleasedDate;
   }

   public String getAssyDataTypeBo() {
      return assyDataTypeBo;
   }

   public void setAssyDataTypeBo(String assyDataTypeBo) {
      this.assyDataTypeBo = assyDataTypeBo;
   }

   public String getPreAssembled() {
      return preAssembled;
   }

   public void setPreAssembled(String preAssembled) {
      this.preAssembled = preAssembled;
   }

   public String getRevision() {
      return revision;
   }

   public void setRevision(String revision) {
      this.revision = revision;
   }

   public String getCurrentRevision() {
      return currentRevision;
   }

   public void setCurrentRevision(String currentRevision) {
      this.currentRevision = currentRevision;
   }

   public LocalDateTime getEffStartDate() {
      return effStartDate;
   }

   public void setEffStartDate(LocalDateTime effStartDate) {
      this.effStartDate = effStartDate;
   }

   public LocalDateTime getEffEndDate() {
      return effEndDate;
   }

   public void setEffEndDate(LocalDateTime effEndDate) {
      this.effEndDate = effEndDate;
   }

   public String getSelectorActivityBo() {
      return selectorActivityBo;
   }

   public void setSelectorActivityBo(String selectorActivityBo) {
      this.selectorActivityBo = selectorActivityBo;
   }

   public String getSelectorNote() {
      return selectorNote;
   }

   public void setSelectorNote(String selectorNote) {
      this.selectorNote = selectorNote;
   }

   public String getAssignSerialAtRelease() {
      return assignSerialAtRelease;
   }

   public void setAssignSerialAtRelease(String assignSerialAtRelease) {
      this.assignSerialAtRelease = assignSerialAtRelease;
   }

   public LocalDateTime getCreatedDateTime() {
      return createdDateTime;
   }

   public void setCreatedDateTime(LocalDateTime createdDateTime) {
      this.createdDateTime = createdDateTime;
   }

   public LocalDateTime getModifiedDateTime() {
      return modifiedDateTime;
   }

   public void setModifiedDateTime(LocalDateTime modifiedDateTime) {
      this.modifiedDateTime = modifiedDateTime;
   }

   public String getDrawingName() {
      return drawingName;
   }

   public void setDrawingName(String drawingName) {
      this.drawingName = drawingName;
   }

   public Long getMaximumUsage() {
      return maximumUsage;
   }

   public void setMaximumUsage(Long maximumUsage) {
      this.maximumUsage = maximumUsage;
   }

   public String getUseCompFromDrawing() {
      return useCompFromDrawing;
   }

   public void setUseCompFromDrawing(String useCompFromDrawing) {
      this.useCompFromDrawing = useCompFromDrawing;
   }

   public String getPanel() {
      return panel;
   }

   public void setPanel(String panel) {
      this.panel = panel;
   }

   public String getRemovalAssyDataTypeBo() {
      return removalAssyDataTypeBo;
   }

   public void setRemovalAssyDataTypeBo(String removalAssyDataTypeBo) {
      this.removalAssyDataTypeBo = removalAssyDataTypeBo;
   }

   public String getInvAssyDataTypeBo() {
      return invAssyDataTypeBo;
   }

   public void setInvAssyDataTypeBo(String invAssyDataTypeBo) {
      this.invAssyDataTypeBo = invAssyDataTypeBo;
   }

   public String getOriginalStatusBo() {
      return originalStatusBo;
   }

   public void setOriginalStatusBo(String originalStatusBo) {
      this.originalStatusBo = originalStatusBo;
   }

   public Double getQtyMultiplier() {
      return qtyMultiplier;
   }

   public void setQtyMultiplier(Double qtyMultiplier) {
      this.qtyMultiplier = qtyMultiplier;
   }

   public String getCreateTrackableSfc() {
      return createTrackableSfc;
   }

   public void setCreateTrackableSfc(String createTrackableSfc) {
      this.createTrackableSfc = createTrackableSfc;
   }

   public String getMaskGroupBo() {
      return maskGroupBo;
   }

   public void setMaskGroupBo(String maskGroupBo) {
      this.maskGroupBo = maskGroupBo;
   }

   public String getTransferItemGroupBo() {
      return transferItemGroupBo;
   }

   public void setTransferItemGroupBo(String transferItemGroupBo) {
      this.transferItemGroupBo = transferItemGroupBo;
   }

   public String getUnitOfMeasure() {
      return unitOfMeasure;
   }

   public void setUnitOfMeasure(String unitOfMeasure) {
      this.unitOfMeasure = unitOfMeasure;
   }

   public Long getHoldId() {
      return holdId;
   }

   public void setHoldId(Long holdId) {
      this.holdId = holdId;
   }

   public String getCollectParentSerial() {
      return collectParentSerial;
   }

   public void setCollectParentSerial(String collectParentSerial) {
      this.collectParentSerial = collectParentSerial;
   }

   public String getReqSerialChange() {
      return reqSerialChange;
   }

   public void setReqSerialChange(String reqSerialChange) {
      this.reqSerialChange = reqSerialChange;
   }

   public String getIsCollector() {
      return isCollector;
   }

   public void setIsCollector(String isCollector) {
      this.isCollector = isCollector;
   }

   public String getIncBatchNumber() {
      return incBatchNumber;
   }

   public void setIncBatchNumber(String incBatchNumber) {
      this.incBatchNumber = incBatchNumber;
   }

   public String getTimeSensitive() {
      return timeSensitive;
   }

   public void setTimeSensitive(String timeSensitive) {
      this.timeSensitive = timeSensitive;
   }

   public Double getMaxShelfLife() {
      return maxShelfLife;
   }

   public void setMaxShelfLife(Double maxShelfLife) {
      this.maxShelfLife = maxShelfLife;
   }

   public String getMaxShelfLifeUnits() {
      return maxShelfLifeUnits;
   }

   public void setMaxShelfLifeUnits(String maxShelfLifeUnits) {
      this.maxShelfLifeUnits = maxShelfLifeUnits;
   }

   public Double getMaxFloorLife() {
      return maxFloorLife;
   }

   public void setMaxFloorLife(Double maxFloorLife) {
      this.maxFloorLife = maxFloorLife;
   }

   public String getMaxFloorLifeUnits() {
      return maxFloorLifeUnits;
   }

   public void setMaxFloorLifeUnits(String maxFloorLifeUnits) {
      this.maxFloorLifeUnits = maxFloorLifeUnits;
   }

   public String getNotes() {
      return notes;
   }

   public void setNotes(String notes) {
      this.notes = notes;
   }

   public String getTbCompType() {
      return tbCompType;
   }

   public void setTbCompType(String tbCompType) {
      this.tbCompType = tbCompType;
   }

   public Double getConsumptionTol() {
      return consumptionTol;
   }

   public void setConsumptionTol(Double consumptionTol) {
      this.consumptionTol = consumptionTol;
   }

   public String getErpBackflushing() {
      return erpBackflushing;
   }

   public void setErpBackflushing(String erpBackflushing) {
      this.erpBackflushing = erpBackflushing;
   }

   public String getStorageLocationBo() {
      return storageLocationBo;
   }

   public void setStorageLocationBo(String storageLocationBo) {
      this.storageLocationBo = storageLocationBo;
   }

   public String getErpPutawayStorloc() {
      return erpPutawayStorloc;
   }

   public void setErpPutawayStorloc(String erpPutawayStorloc) {
      this.erpPutawayStorloc = erpPutawayStorloc;
   }

   public String getProductionSupplyArea() {
      return productionSupplyArea;
   }

   public void setProductionSupplyArea(String productionSupplyArea) {
      this.productionSupplyArea = productionSupplyArea;
   }

   public String getUseOrderIdRel1() {
      return useOrderIdRel1;
   }

   public void setUseOrderIdRel1(String useOrderIdRel1) {
      this.useOrderIdRel1 = useOrderIdRel1;
   }

   public String getMaterialType() {
      return materialType;
   }

   public void setMaterialType(String materialType) {
      this.materialType = materialType;
   }

   public String getProcurementType() {
      return procurementType;
   }

   public void setProcurementType(String procurementType) {
      this.procurementType = procurementType;
   }

   public String getOrigin() {
      return origin;
   }

   public void setOrigin(String origin) {
      this.origin = origin;
   }

   public String getMapNo() {
      return mapNo;
   }

   public void setMapNo(String mapNo) {
      this.mapNo = mapNo;
   }

   public static final String HANDLE = "HANDLE";

   public static final String CHANGE_STAMP = "CHANGE_STAMP";

   public static final String SITE = "SITE";

   public static final String ITEM = "ITEM";

   public static final String DESCRIPTION = "DESCRIPTION";

   public static final String CUSTOMERID = "CUSTOMERID";

   public static final String STATUS_BO = "STATUS_BO";

   public static final String ITEM_TYPE = "ITEM_TYPE";

   public static final String ERP_GTIN = "ERP_GTIN";

   public static final String AIN_MODEL_EXTERNAL_ID = "AIN_MODEL_EXTERNAL_ID";

   public static final String EFF_START_SEQ = "EFF_START_SEQ";

   public static final String EFF_END_SEQ = "EFF_END_SEQ";

   public static final String LOT_SIZE = "LOT_SIZE";

   public static final String QUANTITY_RESTRICTION = "QUANTITY_RESTRICTION";

   public static final String ROUTER_BO = "ROUTER_BO";

   public static final String BOM_BO = "BOM_BO";

   public static final String COMPONENT_GROUP_BO = "COMPONENT_GROUP_BO";

   public static final String ITEM_GROUP_BO = "ITEM_GROUP_BO";

   public static final String LAST_RELEASED_DATE = "LAST_RELEASED_DATE";

   public static final String ASSY_DATA_TYPE_BO = "ASSY_DATA_TYPE_BO";

   public static final String PRE_ASSEMBLED = "PRE_ASSEMBLED";

   public static final String REVISION = "REVISION";

   public static final String CURRENT_REVISION = "CURRENT_REVISION";

   public static final String EFF_START_DATE = "EFF_START_DATE";

   public static final String EFF_END_DATE = "EFF_END_DATE";

   public static final String SELECTOR_ACTIVITY_BO = "SELECTOR_ACTIVITY_BO";

   public static final String SELECTOR_NOTE = "SELECTOR_NOTE";

   public static final String ASSIGN_SERIAL_AT_RELEASE = "ASSIGN_SERIAL_AT_RELEASE";

   public static final String CREATED_DATE_TIME = "CREATED_DATE_TIME";

   public static final String MODIFIED_DATE_TIME = "MODIFIED_DATE_TIME";

   public static final String DRAWING_NAME = "DRAWING_NAME";

   public static final String MAXIMUM_USAGE = "MAXIMUM_USAGE";

   public static final String USE_COMP_FROM_DRAWING = "USE_COMP_FROM_DRAWING";

   public static final String PANEL = "PANEL";

   public static final String REMOVAL_ASSY_DATA_TYPE_BO = "REMOVAL_ASSY_DATA_TYPE_BO";

   public static final String INV_ASSY_DATA_TYPE_BO = "INV_ASSY_DATA_TYPE_BO";

   public static final String ORIGINAL_STATUS_BO = "ORIGINAL_STATUS_BO";

   public static final String QTY_MULTIPLIER = "QTY_MULTIPLIER";

   public static final String CREATE_TRACKABLE_SFC = "CREATE_TRACKABLE_SFC";

   public static final String MASK_GROUP_BO = "MASK_GROUP_BO";

   public static final String TRANSFER_ITEM_GROUP_BO = "TRANSFER_ITEM_GROUP_BO";

   public static final String UNIT_OF_MEASURE = "UNIT_OF_MEASURE";

   public static final String HOLD_ID = "HOLD_ID";

   public static final String COLLECT_PARENT_SERIAL = "COLLECT_PARENT_SERIAL";

   public static final String REQ_SERIAL_CHANGE = "REQ_SERIAL_CHANGE";

   public static final String IS_COLLECTOR = "IS_COLLECTOR";

   public static final String INC_BATCH_NUMBER = "INC_BATCH_NUMBER";

   public static final String TIME_SENSITIVE = "TIME_SENSITIVE";

   public static final String MAX_SHELF_LIFE = "MAX_SHELF_LIFE";

   public static final String MAX_SHELF_LIFE_UNITS = "MAX_SHELF_LIFE_UNITS";

   public static final String MAX_FLOOR_LIFE = "MAX_FLOOR_LIFE";

   public static final String MAX_FLOOR_LIFE_UNITS = "MAX_FLOOR_LIFE_UNITS";

   public static final String NOTES = "NOTES";

   public static final String TB_COMP_TYPE = "TB_COMP_TYPE";

   public static final String CONSUMPTION_TOL = "CONSUMPTION_TOL";

   public static final String ERP_BACKFLUSHING = "ERP_BACKFLUSHING";

   public static final String STORAGE_LOCATION_BO = "STORAGE_LOCATION_BO";

   public static final String ERP_PUTAWAY_STORLOC = "ERP_PUTAWAY_STORLOC";

   public static final String PRODUCTION_SUPPLY_AREA = "PRODUCTION_SUPPLY_AREA";

   public static final String USE_ORDER_ID_REL1 = "USE_ORDER_ID_REL1";

   @Override
   protected Serializable pkVal() {
      return this.handle;
   }

   @Override
   public String toString() {
      return "Item{" +
         "handle = " + handle +
         ", changeStamp = " + changeStamp +
         ", site = " + site +
         ", item = " + item +
         ", statusBo = " + statusBo +
         ", itemType = " + itemType +
         ", erpGtin = " + erpGtin +
         ", ainModelExternalId = " + ainModelExternalId +
         ", effStartSeq = " + effStartSeq +
         ", effEndSeq = " + effEndSeq +
         ", lotSize = " + lotSize +
         ", quantityRestriction = " + quantityRestriction +
         ", routerBo = " + routerBo +
         ", bomBo = " + bomBo +
         ", componentGroupBo = " + componentGroupBo +
         ", itemGroupBo = " + itemGroupBo +
         ", lastReleasedDate = " + lastReleasedDate +
         ", assyDataTypeBo = " + assyDataTypeBo +
         ", preAssembled = " + preAssembled +
         ", revision = " + revision +
         ", currentRevision = " + currentRevision +
         ", effStartDate = " + effStartDate +
         ", effEndDate = " + effEndDate +
         ", selectorActivityBo = " + selectorActivityBo +
         ", selectorNote = " + selectorNote +
         ", assignSerialAtRelease = " + assignSerialAtRelease +
         ", createdDateTime = " + createdDateTime +
         ", modifiedDateTime = " + modifiedDateTime +
         ", drawingName = " + drawingName +
         ", maximumUsage = " + maximumUsage +
         ", useCompFromDrawing = " + useCompFromDrawing +
         ", panel = " + panel +
         ", removalAssyDataTypeBo = " + removalAssyDataTypeBo +
         ", invAssyDataTypeBo = " + invAssyDataTypeBo +
         ", originalStatusBo = " + originalStatusBo +
         ", qtyMultiplier = " + qtyMultiplier +
         ", createTrackableSfc = " + createTrackableSfc +
         ", maskGroupBo = " + maskGroupBo +
         ", transferItemGroupBo = " + transferItemGroupBo +
         ", unitOfMeasure = " + unitOfMeasure +
         ", holdId = " + holdId +
         ", collectParentSerial = " + collectParentSerial +
         ", reqSerialChange = " + reqSerialChange +
         ", isCollector = " + isCollector +
         ", incBatchNumber = " + incBatchNumber +
         ", timeSensitive = " + timeSensitive +
         ", maxShelfLife = " + maxShelfLife +
         ", maxShelfLifeUnits = " + maxShelfLifeUnits +
         ", maxFloorLife = " + maxFloorLife +
         ", maxFloorLifeUnits = " + maxFloorLifeUnits +
         ", notes = " + notes +
         ", tbCompType = " + tbCompType +
         ", consumptionTol = " + consumptionTol +
         ", erpBackflushing = " + erpBackflushing +
         ", storageLocationBo = " + storageLocationBo +
         ", erpPutawayStorloc = " + erpPutawayStorloc +
         ", productionSupplyArea = " + productionSupplyArea +
         ", useOrderIdRel1 = " + useOrderIdRel1 +
         ", materialType = " + materialType +
         ", procurementType = " + procurementType +
         ", origin = " + origin +
         "}";
   }
}